Marriage Match IV(最短路径+最大流)

2023-11-08 11:38

本文主要是介绍Marriage Match IV(最短路径+最大流),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3416

题目大意:求最短路的个数

题目思路:先用SPFA求出最短路径,然后用SAP算法求出最大网络流,即最短的个数,以最短路径上的边建图,用邻接链表存边

题目:

Marriage Match IV

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1478    Accepted Submission(s): 412


Problem Description
Do not sincere non-interference。
Like that show, now starvae also take part in a show, but it take place between city A and B. Starvae is in city A and girls are in city B. Every time starvae can get to city B and make a data with a girl he likes. But there are two problems with it, one is starvae must get to B within least time, it's said that he must take a shortest path. Other is no road can be taken more than once. While the city starvae passed away can been taken more than once.


So, under a good RP, starvae may have many chances to get to city B. But he don't know how many chances at most he can make a data with the girl he likes . Could you help starvae?

Input
The first line is an integer T indicating the case number.(1<=T<=65)
For each case,there are two integer n and m in the first line ( 2<=n<=1000, 0<=m<=100000 ) ,n is the number of the city and m is the number of the roads.

Then follows m line ,each line have three integers a,b,c,(1<=a,b<=n,0<c<=1000)it means there is a road from a to b and it's distance is c, while there may have no road from b to a. There may have a road from a to a,but you can ignore it. If there are two roads from a to b, they are different.

At last is a line with two integer A and B(1<=A,B<=N,A!=B), means the number of city A and city B.
There may be some blank line between each case.

Output
Output a line with a integer, means the chances starvae can get at most.

Sample Input
  
3 7 8 1 2 1 1 3 1 2 4 1 3 4 1 4 5 1 4 6 1 5 7 1 6 7 1 1 76 7 1 2 1 2 3 1 1 3 3 3 4 1 3 5 1 4 6 1 5 6 1 1 62 2 1 2 1 1 2 2 1 2

Sample Output
  
2 1 1
#include <iostream>
#include <queue>
#include <vector>
#include<string.h>
#include<stdio.h>
using namespace std;
const int inf=0x3f3f3f3f;
struct rec
{int u,v,w,link;
} edge[300005];
struct re
{int v,c;
};
vector<re> E[1005];
bool vis[1005];
int head[1005],pre[1005],cur[1005],dis[1005],gap[1005];
int n,m,num,st,ed;
inline void addedge(int u,int v,int w)
{edge[num].u=u;edge[num].v=v;edge[num].w=w;edge[num].link=head[u];head[u]=num++;edge[num].u=v;edge[num].v=u;edge[num].w=0;edge[num].link=head[v];head[v]=num++;
}
void SPFA()
{int i,v,u;memset(vis,0,sizeof(vis));for(i=1; i<=n; i++)dis[i]=inf;queue<int> Q;dis[st]=0;Q.push(st);while(!Q.empty()){u=Q.front();Q.pop();vis[u]=0;for(i=0; i<E[u].size(); i++){v=E[u][i].v;if(dis[v]>dis[u]+E[u][i].c){dis[v]=dis[u]+E[u][i].c;if(!vis[v]){vis[v]=1;Q.push(v);}}}}
}
int max_flow()
{int i,k,u,v,aug=inf,ans=0;memset(dis,0,sizeof(dis));memset(gap,0,sizeof(gap));gap[0]=n;u=pre[st]=st;for(i=1; i<=n; i++)cur[i]=head[i];while(dis[st]<n){
loop:for(i=cur[u]; i; i=cur[u]=edge[i].link){v=edge[i].v;if(dis[u]==dis[v]+1 && edge[i].w){pre[v]=u;u=v;if(aug>edge[i].w)aug=edge[i].w;if(v==ed){for(u=pre[v]; v!=st; v=u,u=pre[u]){edge[cur[u]].w-=aug;edge[cur[u]^1].w+=aug;}ans+=aug;aug=inf;}goto loop;}}k=n;for(i=head[u]; i; i=edge[i].link){v=edge[i].v;if(k>dis[v] && edge[i].w){cur[u]=i;k=dis[v];}}if(--gap[dis[u]]==0)break;gap[dis[u]=k+1]++;u=pre[u];}return ans;
}
int main()
{int T,i,j,u,v,c;re tmp;scanf("%d",&T);while(T--){scanf("%d%d",&n,&m);for(i=1; i<=n; i++)E[i].clear();num=2;memset(head,0,sizeof(head));for(i=1; i<=m; i++){scanf("%d%d%d",&u,&v,&c);if(u==v)continue;tmp.v=v;tmp.c=c;E[u].push_back(tmp);}scanf("%d%d",&st,&ed);SPFA();for(i=1; i<=n; i++)for(j=0; j<E[i].siz e(); j++)if(dis[E[i][j].v]==dis[i]+E[i][j].c)addedge(i,E[i][j].v,1);printf("%d\n",max_flow());}return 0;
}



这篇关于Marriage Match IV(最短路径+最大流)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/369599

相关文章

hdu2544(单源最短路径)

模板题: //题意:求1到n的最短路径,模板题#include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#i

poj 1734 (floyd求最小环并打印路径)

题意: 求图中的一个最小环,并打印路径。 解析: ans 保存最小环长度。 一直wa,最后终于找到原因,inf开太大爆掉了。。。 虽然0x3f3f3f3f用memset好用,但是还是有局限性。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#incl

poj 3723 kruscal,反边取最大生成树。

题意: 需要征募女兵N人,男兵M人。 每征募一个人需要花费10000美元,但是如果已经招募的人中有一些关系亲密的人,那么可以少花一些钱。 给出若干的男女之间的1~9999之间的亲密关系度,征募某个人的费用是10000 - (已经征募的人中和自己的亲密度的最大值)。 要求通过适当的招募顺序使得征募所有人的费用最小。 解析: 先设想无向图,在征募某个人a时,如果使用了a和b之间的关系

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2175 最小费用最大流TLE

题意: 一条街上有n个大楼,坐标为xi,yi,bi个人在里面工作。 然后防空洞的坐标为pj,qj,可以容纳cj个人。 从大楼i中的人到防空洞j去避难所需的时间为 abs(xi - pi) + (yi - qi) + 1。 现在设计了一个避难计划,指定从大楼i到防空洞j避难的人数 eij。 判断如果按照原计划进行,所有人避难所用的时间总和是不是最小的。 若是,输出“OPETIMAL",若

poj 2135 有流量限制的最小费用最大流

题意: 农场里有n块地,其中约翰的家在1号地,二n号地有个很大的仓库。 农场有M条道路(双向),道路i连接着ai号地和bi号地,长度为ci。 约翰希望按照从家里出发,经过若干块地后到达仓库,然后再返回家中的顺序带朋友参观。 如果要求往返不能经过同一条路两次,求参观路线总长度的最小值。 解析: 如果只考虑去或者回的情况,问题只不过是无向图中两点之间的最短路问题。 但是现在要去要回

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3422 有流量限制的最小费用流 反用求最大 + 拆点

题意: 给一个n*n(50 * 50) 的数字迷宫,从左上点开始走,走到右下点。 每次只能往右移一格,或者往下移一格。 每个格子,第一次到达时可以获得格子对应的数字作为奖励,再次到达则没有奖励。 问走k次这个迷宫,最大能获得多少奖励。 解析: 拆点,拿样例来说明: 3 2 1 2 3 0 2 1 1 4 2 3*3的数字迷宫,走两次最大能获得多少奖励。 将每个点拆成两个

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(

最大流、 最小费用最大流终极版模板

最大流  const int inf = 1000000000 ;const int maxn = 20000 , maxm = 500000 ;struct Edge{int v , f ,next ;Edge(){}Edge(int _v , int _f , int _next):v(_v) ,f(_f),next(_next){}};int sourse , mee